# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (c) 2008 Zikzakmedia S.L. (http://zikzakmedia.com) All Rights Reserved.
#                       Jordi Esteve <jesteve@zikzakmedia.com>
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv,orm
import xmlrpclib


class esale_oscom_web(osv.osv):
    _inherit = 'esale.oscom.web'

    def product_extra_info_m2m(self, cr, uid, website, prod_id, prod_data):
        """Module to import m2m categories for oscommerce products"""
        product_obj = self.pool.get('product.template')
        esale_category_obj = self.pool.get('esale.oscom.category')
        info_prod = prod_data['product']
        print "En extra info"

        server = xmlrpclib.ServerProxy("%s/openerp-synchro.php" % website.url)
        # m2m oscommerce product category mapping
        p_osc_categories = server.get_m2m_cat(info_prod['products_id'])
        print "==========Categorias Web del producto: " , p_osc_categories
        
        oerp_osc_categ = esale_category_obj.search(cr, uid, [('web_id','=',website.id), ('esale_oscom_id','in', p_osc_categories)])
        cats_ids =[]
        if oerp_osc_categ:
            for idct in oerp_osc_categ:
                cat_id = esale_category_obj.read(cr, uid, idct, ['category_id'])
                cats_ids.append(cat_id['category_id'][0])

        value_cat = {
            'categ_ids': [(6, 0,  cats_ids )]
            }

        self.pool.get('product.template').write(cr, uid, [prod_id], value_cat)

        return True
esale_oscom_web()

class esale_oscom_product_inherit(osv.osv):
    _inherit = 'product.product'

    def product_extra_info_m2m(self, cr, uid, website, esale_product):
        esale_category_obj = self.pool.get('esale.oscom.category')
        print "Updateando Categorias en Tienda"
        print esale_product.esale_oscom_id

        print esale_product.product_id.categ_ids
        cat_ids = [cat.id for cat in esale_product.product_id.categ_ids]
        oerp_osc_categ = esale_category_obj.search(cr, uid, [('web_id','=',website.id), ('category_id','in', cat_ids)])
        cats_ids =[]
        if oerp_osc_categ:
            for idct in oerp_osc_categ:
                cat_id = esale_category_obj.read(cr, uid, idct, ['esale_oscom_id'])
                cats_ids.append(cat_id['esale_oscom_id'])
        print cats_ids
        server = xmlrpclib.ServerProxy("%s/openerp-synchro.php" % website.url)
        server.set_m2m_cat(esale_product.esale_oscom_id, cats_ids)
        return True

esale_oscom_product_inherit()



